/**
 * @author mna
 */

/**
 * jQuery function check document loaded and invoke argument function
 */
$(document).ready(function() {
	console.log('ready!');
	application();
});

/**
 * Main function include all application logic
 * 
 */
var application = function() {

	/**
	 * Object creation example
	 */
	var myObject = {
		sayHello : function() {
			console.log('hello');
		},
		myName : 'Rebecca'
	};

	myObject.sayHello(); // logs 'hello'
	console.log(myObject.myName); // logs 'Rebecca'

	/**
	 * get element reference and get element properties
	 */
	var h2obj = $('h2');
	var h2obj = $('#h2Text1');
	console.log(h2obj.width());
	console.log(h2obj.position().top);
	h2obj.text('New H2 text');

	var oldAttribute = $('a').attr('href');
	$('a').attr('href', 'http://plugins.jquery.com/');

	/**
	 * Elements manipulation clone, insert new element etc
	 */
	var h2objClone = h2obj.clone();
	h2objClone.insertAfter(h2obj);

	h2objClone.attr('id', 'h2objClone');
	// What about get reference? Array of elements
	var h2objAfterInsertion = $('h2');
	var h2objAfterInsertion = $('#h2objClone');

	var newParagraph = $('<p>This is a new paragraph</p>');

	newParagraph.insertAfter($('a'));

	/**
	 * Utility functions
	 */
	var firstObject = {
		foo : 'bar',
		a : 'b'
	};
	var secondObject = {
		foo : 'baz'
	};

	var newObject = $.extend(firstObject, secondObject);
	console.log(firstObject); // 'baz'
	console.log(newObject); // 'baz'

	/**
	 * Effects
	 */
	for ( var i = 1; i < 3; i++) {
		h2objClone.fadeOut('slow'); // using a built-in speed definition
		h2objClone.fadeIn('slow');
	}

	/**
	 * AJAX JSON 
	 */
	var getCustomerData = function() {
		$.ajax( {
			url : 'jsonData.jsp',
			data : {
				id : 123
			},
			method : 'GET',
			dataType : 'json',
			success : function(json) {
				$('#testDiv').text('Customer data');
				$('#testDiv').append('<ul id="humanData"></ul>');
				$('#humanData').append('<li>' + json.name + '</li>');
				$('#humanData').append('<li>' + json.job + '</li>');
				$('#humanData').append('<li>' + json.age + '</li>');
			},

			error : function(xhr, status) {
				//alert('Sorry, there was a problem!');
			},
			complete : function(xhr, status) {
				//alert('The request is complete!');
			}
		});
	}
	
	
	$('#getDataButton').click(getCustomerData);
	
	var endOffunction = true;
}